Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.cpp	(revision 98555)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.cpp	(revision 98556)
@@ -459,4 +459,19 @@
 {
     return uisession()->acquireScreenShot(uScreenId, uWidth, uHeight, enmFormat, pBits);
+}
+
+bool UIMachine::notifyScaleFactorChange(ulong uScreenId, ulong uScaleFactorWMultiplied, ulong uScaleFactorHMultiplied)
+{
+    return uisession()->notifyScaleFactorChange(uScreenId, uScaleFactorWMultiplied, uScaleFactorHMultiplied);
+}
+
+bool UIMachine::notifyHiDPIOutputPolicyChange(bool fUnscaledHiDPI)
+{
+    return uisession()->notifyHiDPIOutputPolicyChange(fUnscaledHiDPI);
+}
+
+bool UIMachine::setSeamlessMode(bool fEnabled)
+{
+    return uisession()->setSeamlessMode(fEnabled);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.h	(revision 98555)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.h	(revision 98556)
@@ -291,4 +291,10 @@
         /** Acquires screen-shot for guest-screen with passed uScreenId. */
         bool acquireScreenShot(ulong uScreenId, ulong uWidth, ulong uHeight, KBitmapFormat enmFormat, uchar *pBits);
+        /** Notifies guest-screen with passed uScreenId about scale-factor change. */
+        bool notifyScaleFactorChange(ulong uScreenId, ulong uScaleFactorWMultiplied, ulong uScaleFactorHMultiplied);
+        /** Notifies display about unscaled HiDPI policy change. */
+        bool notifyHiDPIOutputPolicyChange(bool fUnscaledHiDPI);
+        /** Defines whether seamless mode is enabled for display. */
+        bool setSeamlessMode(bool fEnabled);
     /** @} */
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp	(revision 98555)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp	(revision 98556)
@@ -249,8 +249,8 @@
             dScaleFactorFor3D *= frameBuffer()->devicePixelRatioActual();
 #endif /* VBOX_WS_WIN || VBOX_WS_X11 */
-        display().NotifyScaleFactorChange(m_uScreenId,
-                                          (uint32_t)(dScaleFactorFor3D * VBOX_OGL_SCALE_FACTOR_MULTIPLIER),
-                                          (uint32_t)(dScaleFactorFor3D * VBOX_OGL_SCALE_FACTOR_MULTIPLIER));
-        display().NotifyHiDPIOutputPolicyChange(fUseUnscaledHiDPIOutput);
+        uimachine()->notifyScaleFactorChange(m_uScreenId,
+                                             (uint32_t)(dScaleFactorFor3D * VBOX_OGL_SCALE_FACTOR_MULTIPLIER),
+                                             (uint32_t)(dScaleFactorFor3D * VBOX_OGL_SCALE_FACTOR_MULTIPLIER));
+        uimachine()->notifyHiDPIOutputPolicyChange(fUseUnscaledHiDPIOutput);
     }
 
@@ -1002,8 +1002,8 @@
             dScaleFactorFor3D *= frameBuffer()->devicePixelRatioActual();
 #endif /* VBOX_WS_WIN || VBOX_WS_X11 */
-        display().NotifyScaleFactorChange(m_uScreenId,
-                                          (uint32_t)(dScaleFactorFor3D * VBOX_OGL_SCALE_FACTOR_MULTIPLIER),
-                                          (uint32_t)(dScaleFactorFor3D * VBOX_OGL_SCALE_FACTOR_MULTIPLIER));
-        display().NotifyHiDPIOutputPolicyChange(fUseUnscaledHiDPIOutput);
+        uimachine()->notifyScaleFactorChange(m_uScreenId,
+                                             (uint32_t)(dScaleFactorFor3D * VBOX_OGL_SCALE_FACTOR_MULTIPLIER),
+                                             (uint32_t)(dScaleFactorFor3D * VBOX_OGL_SCALE_FACTOR_MULTIPLIER));
+        uimachine()->notifyHiDPIOutputPolicyChange(fUseUnscaledHiDPIOutput);
     }
 
@@ -1234,8 +1234,8 @@
                 dScaleFactorFor3D *= dDevicePixelRatioActual;
 #endif /* VBOX_WS_WIN || VBOX_WS_X11 */
-            display().NotifyScaleFactorChange(m_uScreenId,
-                                              (uint32_t)(dScaleFactorFor3D * VBOX_OGL_SCALE_FACTOR_MULTIPLIER),
-                                              (uint32_t)(dScaleFactorFor3D * VBOX_OGL_SCALE_FACTOR_MULTIPLIER));
-            display().NotifyHiDPIOutputPolicyChange(fUseUnscaledHiDPIOutput);
+            uimachine()->notifyScaleFactorChange(m_uScreenId,
+                                                 (uint32_t)(dScaleFactorFor3D * VBOX_OGL_SCALE_FACTOR_MULTIPLIER),
+                                                 (uint32_t)(dScaleFactorFor3D * VBOX_OGL_SCALE_FACTOR_MULTIPLIER));
+            uimachine()->notifyHiDPIOutputPolicyChange(fUseUnscaledHiDPIOutput);
         }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 98555)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 98556)
@@ -483,4 +483,34 @@
             UINotificationMessage::cannotAcquireDisplayParameter(comDisplay);
     }
+    return fSuccess;
+}
+
+bool UISession::notifyScaleFactorChange(ulong uScreenId, ulong uScaleFactorWMultiplied, ulong uScaleFactorHMultiplied)
+{
+    CDisplay comDisplay = display();
+    comDisplay.NotifyScaleFactorChange(uScreenId, uScaleFactorWMultiplied, uScaleFactorHMultiplied);
+    const bool fSuccess = comDisplay.isOk();
+    if (!fSuccess)
+        UINotificationMessage::cannotChangeDisplayParameter(comDisplay);
+    return fSuccess;
+}
+
+bool UISession::notifyHiDPIOutputPolicyChange(bool fUnscaledHiDPI)
+{
+    CDisplay comDisplay = display();
+    comDisplay.NotifyHiDPIOutputPolicyChange(fUnscaledHiDPI);
+    const bool fSuccess = comDisplay.isOk();
+    if (!fSuccess)
+        UINotificationMessage::cannotChangeDisplayParameter(comDisplay);
+    return fSuccess;
+}
+
+bool UISession::setSeamlessMode(bool fEnabled)
+{
+    CDisplay comDisplay = display();
+    comDisplay.SetSeamlessMode(fEnabled);
+    const bool fSuccess = comDisplay.isOk();
+    if (!fSuccess)
+        UINotificationMessage::cannotChangeDisplayParameter(comDisplay);
     return fSuccess;
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h	(revision 98555)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h	(revision 98556)
@@ -309,4 +309,10 @@
         /** Acquires screen-shot for guest-screen with passed uScreenId. */
         bool acquireScreenShot(ulong uScreenId, ulong uWidth, ulong uHeight, KBitmapFormat enmFormat, uchar *pBits);
+        /** Notifies guest-screen with passed uScreenId about scale-factor change. */
+        bool notifyScaleFactorChange(ulong uScreenId, ulong uScaleFactorWMultiplied, ulong uScaleFactorHMultiplied);
+        /** Notifies display about unscaled HiDPI policy change. */
+        bool notifyHiDPIOutputPolicyChange(bool fUnscaledHiDPI);
+        /** Defines whether seamless mode is enabled for display. */
+        bool setSeamlessMode(bool fEnabled);
     /** @} */
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineLogicNormal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineLogicNormal.cpp	(revision 98555)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineLogicNormal.cpp	(revision 98556)
@@ -51,5 +51,4 @@
 /* COM includes: */
 #include "CConsole.h"
-#include "CDisplay.h"
 #include "CGraphicsAdapter.h"
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineViewScale.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineViewScale.cpp	(revision 98555)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineViewScale.cpp	(revision 98556)
@@ -41,5 +41,4 @@
 
 /* COM includes: */
-#include "CDisplay.h"
 #include "CGraphicsAdapter.h"
 
@@ -85,7 +84,7 @@
             }
 #endif /* VBOX_WS_WIN || VBOX_WS_X11 */
-            display().NotifyScaleFactorChange(m_uScreenId,
-                                              (uint32_t)(xScaleFactor * VBOX_OGL_SCALE_FACTOR_MULTIPLIER),
-                                              (uint32_t)(yScaleFactor * VBOX_OGL_SCALE_FACTOR_MULTIPLIER));
+            uimachine()->notifyScaleFactorChange(m_uScreenId,
+                                                 (uint32_t)(xScaleFactor * VBOX_OGL_SCALE_FACTOR_MULTIPLIER),
+                                                 (uint32_t)(yScaleFactor * VBOX_OGL_SCALE_FACTOR_MULTIPLIER));
         }
     }
@@ -144,7 +143,7 @@
             }
 #endif /* VBOX_WS_WIN || VBOX_WS_X11 */
-            display().NotifyScaleFactorChange(m_uScreenId,
-                                              (uint32_t)(xScaleFactor * VBOX_OGL_SCALE_FACTOR_MULTIPLIER),
-                                              (uint32_t)(yScaleFactor * VBOX_OGL_SCALE_FACTOR_MULTIPLIER));
+            uimachine()->notifyScaleFactorChange(m_uScreenId,
+                                                 (uint32_t)(xScaleFactor * VBOX_OGL_SCALE_FACTOR_MULTIPLIER),
+                                                 (uint32_t)(yScaleFactor * VBOX_OGL_SCALE_FACTOR_MULTIPLIER));
         }
     }
@@ -154,5 +153,5 @@
     /* Propagate unscaled-hidpi-output feature to 3D service if necessary: */
     if (machine().GetGraphicsAdapter().GetAccelerate3DEnabled())
-        display().NotifyHiDPIOutputPolicyChange(fUseUnscaledHiDPIOutput);
+        uimachine()->notifyHiDPIOutputPolicyChange(fUseUnscaledHiDPIOutput);
 
     /* Perform frame-buffer rescaling: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineViewSeamless.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineViewSeamless.cpp	(revision 98555)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineViewSeamless.cpp	(revision 98556)
@@ -46,5 +46,4 @@
 /* COM includes: */
 #include "CConsole.h"
-#include "CDisplay.h"
 
 /* Other VBox includes: */
@@ -136,5 +135,5 @@
 {
     /* Set seamless feature flag to the guest: */
-    display().SetSeamlessMode(true);
+    uimachine()->setSeamlessMode(true);
 }
 
@@ -143,5 +142,5 @@
     /* Reset seamless feature flag if possible: */
     if (uimachine()->isRunning())
-        display().SetSeamlessMode(false);
+        uimachine()->setSeamlessMode(false);
 }
 