Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.cpp	(revision 98606)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.cpp	(revision 98607)
@@ -646,4 +646,9 @@
 }
 #endif /* VBOX_WITH_DEBUGGER_GUI */
+
+bool UIMachine::acquireWhetherGuestEnteredACPIMode(bool &fEntered)
+{
+    return uisession()->acquireWhetherGuestEnteredACPIMode(fEntered);
+}
 
 void UIMachine::detachUi()
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.h	(revision 98606)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.h	(revision 98607)
@@ -490,4 +490,7 @@
         MachineCloseAction restrictedCloseActions() const { return m_restrictedCloseActions; }
 
+        /** Acquires whether guest @a fEntered ACPI mode. */
+        bool acquireWhetherGuestEnteredACPIMode(bool &fEntered);
+
         /** Detaches and closes Runtime UI. */
         void detachUi();
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp	(revision 98606)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp	(revision 98607)
@@ -54,5 +54,4 @@
 
 /* COM includes: */
-#include "CConsole.h"
 #include "CGraphicsAdapter.h"
 #include "CSnapshot.h"
@@ -227,9 +226,4 @@
 }
 
-CConsole& UIMachineWindow::console() const
-{
-    return uisession()->console();
-}
-
 QString UIMachineWindow::machineName() const
 {
@@ -430,6 +424,8 @@
         /* Prepare close-dialog: */
         QWidget *pParentDlg = windowManager().realParentWindow(this);
+        bool fInACPIMode = false;
+        uimachine()->acquireWhetherGuestEnteredACPIMode(fInACPIMode);
         QPointer<UIVMCloseDialog> pCloseDlg = new UIVMCloseDialog(pParentDlg, machine(),
-                                                                  console().GetGuestEnteredACPIMode(),
+                                                                  fInACPIMode,
                                                                   restrictedCloseActions);
         /* Configure close-dialog: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.h	(revision 98606)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.h	(revision 98607)
@@ -96,6 +96,4 @@
     /** Returns the session's machine reference. */
     CMachine& machine() const;
-    /** Returns the session's console reference. */
-    CConsole& console() const;
 
     /** Returns the machine name. */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 98606)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 98607)
@@ -792,4 +792,16 @@
 #endif /* VBOX_WITH_DEBUGGER_GUI */
 
+bool UISession::acquireWhetherGuestEnteredACPIMode(bool &fEntered)
+{
+    CConsole comConsole = console();
+    const BOOL fGuestEntered = comConsole.GetGuestEnteredACPIMode();
+    const bool fSuccess = comConsole.isOk();
+    if (!fSuccess)
+        UINotificationMessage::cannotAcquireConsoleParameter(comConsole);
+    else
+        fEntered = fGuestEntered == TRUE;
+    return fSuccess;
+}
+
 bool UISession::prepareToBeSaved()
 {
@@ -800,5 +812,6 @@
 bool UISession::prepareToBeShutdowned()
 {
-    const bool fValidMode = console().GetGuestEnteredACPIMode();
+    bool fValidMode = false;
+    acquireWhetherGuestEnteredACPIMode(fValidMode);
     if (!fValidMode)
         UINotificationMessage::cannotSendACPIToMachine();
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h	(revision 98606)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h	(revision 98607)
@@ -392,4 +392,7 @@
     /** @name Close stuff.
      ** @{ */
+        /** Acquires whether guest @a fEntered ACPI mode. */
+        bool acquireWhetherGuestEnteredACPIMode(bool &fEntered);
+
         /** Prepares VM to be saved. */
         bool prepareToBeSaved();