Index: trunk/doc/manual/en_US/dita/UserManual.ditamap
===================================================================
--- trunk/doc/manual/en_US/dita/user.ditamap	(revision 98623)
+++ trunk/doc/manual/en_US/dita/UserManual.ditamap	(revision 98657)
@@ -3,9 +3,9 @@
 <!-- The bookmap ID is imperative and matched the Jarvis GUID required to build and pretty much do anything -->
 <bookmap id="EN-VBOX-7-0-USER" xml:lang="en-US">
-   <!-- 
-         booklibrary renders in bold and is equivalent to title in docbook; 
+   <!--
+         booklibrary renders in bold and is equivalent to title in docbook;
          mainbooktitle is not in bold and is equivalent to subtitle
-         
-         This information gets updated automatically to match the othermeta title value or PDB entry when you run: 
+
+         This information gets updated automatically to match the othermeta title value or PDB entry when you run:
          'DitaUtils.py title -d template.ditamap' or 'DitaUtils.py map-prep -d template.ditamap'
     -->
@@ -23,10 +23,10 @@
          </published>
       </publisherinformation>
-      
-      <!-- 
-         The othermeta title is used as the title for the book in Jarvis and in OHC search. 
+
+      <!--
+         The othermeta title is used as the title for the book in Jarvis and in OHC search.
          If you don't set this, the value in PDB is used.
          The booklibrary and mainbooktitle automatically get updated from this title!
-         
+
          Use a : character to distinguish booklibrary from mainbooktitle
          To make sure the title is correctly set run:
@@ -34,14 +34,14 @@
       -->
       <othermeta name="title" content="Oracle VM VirtualBox: User Guide for Release 7.0"/>
-      
-      <!-- 
-           Th othermeta pubAlias detemines what the final part of the URL for your book will be (the pubalias in Jarvis). 
+
+      <!--
+           Th othermeta pubAlias detemines what the final part of the URL for your book will be (the pubalias in Jarvis).
            If you don't set it, it will default to the docid in PDB.
       -->
          <othermeta name="pubAlias" content="user"/>
          <othermeta name="jarvis-url" content="https://docs.oracle.com/en/virtualization/virtualbox/7.0/user/"/>
-      <!-- 
-         For SVN Revision information, you *must* do: `svn propset svn:keywords "Date Author Rev" template.ditamap` 
-         on the ditamap when you first add it. You can automatically handle this by editing ~/.subversion/config 
+      <!--
+         For SVN Revision information, you *must* do: `svn propset svn:keywords "Date Author Rev" template.ditamap`
+         on the ditamap when you first add it. You can automatically handle this by editing ~/.subversion/config
          to add a line entry under [auto-props]:
          *.ditamap = svn:mime-type=text/xml;svn:keywords=Author Date Id Rev URL;
@@ -62,6 +62,6 @@
          </bookrights>
    </bookmeta>
-   <!-- 
-    Chunking at chapter level is handled automatically by running:  
+   <!--
+    Chunking at chapter level is handled automatically by running:
     DitaUtils.py chunk -d template.ditamap or 'DitaUtils.py map-prep -d template.ditamap'
   -->
@@ -347,5 +347,5 @@
          <topicref href="topics/network_performance.dita"/>
       </chapter>
-   
+
    <chapter href="topics/remotevm.dita">
       <topicref href="topics/vrde.dita">
@@ -371,12 +371,12 @@
          </topicref>-->
    </chapter>
-   
+
    <!-- VBoxManage Refentry command topics -->
    <chapter href="topics/vboxmanage.dita">
-      <topicref href="topics/vboxmanage-intro.dita"/> 
-      <!-- Commands Overview -->      
+      <topicref href="topics/vboxmanage-intro.dita"/>
+      <!-- Commands Overview -->
       <!--  <topicref href="topics/vboxmanage-cmd-overview.dita"/> -->
       <topicref href="topics/vboxmanage-general.dita"/>
-      <topicref href="topics/man_VBoxManage-common.dita"/>      
+      <topicref href="topics/man_VBoxManage-common.dita"/>
       <topicref href="topics/man_VBoxManage-adoptstate.dita"/>
       <topicref href="topics/man_VBoxManage-checkmediumpwd.dita"/>
@@ -436,5 +436,5 @@
 <!--      <topicref href="topics/man_VBoxManage-cloudlist.dita"/>      -->
    </chapter>
-   
+
    <chapter href="topics/AdvancedTopics.dita">
       <topicref href="topics/autologon.dita">
@@ -561,7 +561,7 @@
          <topicref href="topics/vboxsvc-session-0-known-issues.dita"/>
       </topicref>
-      
+
       <!-- <topicref href="topics/viso.dita"> -->
-         
+
    </chapter>
    <chapter href="topics/TechnicalBackground.dita">
@@ -578,7 +578,7 @@
       <topicref href="topics/nestedpaging.dita"/>
    </chapter>
-   
+
    <chapter href="topics/VirtualBoxAPI.dita"/>
-   
+
    <chapter href="topics/Troubleshooting.dita">
       <topicref href="topics/ts_procs-tools.dita">
@@ -641,5 +641,5 @@
       </topicref>
    </chapter>
-   
+
    <chapter href="topics/Security.dita">
       <topicref href="topics/security-general.dita"/>
@@ -673,16 +673,16 @@
       </topicref>
    </chapter>
-   
+
    <chapter href="topics/KnownIssues.dita">
       <topicref href="topics/ExperimentalFeatures.dita"/>
       <topicref href="topics/KnownProblems.dita"/>
    </chapter>
-   
+
    <!-- Change Log-->
-   
+
    <!-- Third Party Licenses-->
-   
+
    <chapter href="topics/privacy.dita"/>
- 
+
 <chapter href="topics/Glossary.dita" chunk="to-content">
     <topicref href="topics/glossentry-acpi.dita"/>
@@ -725,4 +725,4 @@
     <topicref href="topics/glossentry-xml.dita"/>
     <topicref href="topics/glossentry-xpcom.dita"/>
-</chapter> 
+</chapter>
 </bookmap>